#!c:/Perl/bin/Perl.exe -w

use strict;
use Fcntl qw(:DEFAULT :flock);
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use Encode qw(from_to decode encode);
use open ':utf8';
use encoding 'utf8', STDOUT=>'shiftjis';

#定義
my $datafile = "C:\\Apache2\\data\\bbs.dat";

#メイン
{
	my $obj = CGI->new;
	my $hash_ref = &get_FormData($obj);
	&check_FormData($hash_ref);	
	&add_FileData($datafile,$hash_ref);
	my $string = "<BR>登録が完了しました。<BR>";
	&display_HTML($string);

	exit;
}

#サブルーチン
sub get_FormData {
	my $obj = shift;
	my @hash_name = $obj->param;
	my %hash;
	foreach my $key(@hash_name)
	{
		$hash{$key} = decode('shiftjis', $obj->param($key));
		next if $hash{$key} =~ /^\s*$/;
		$hash{$key} =~ s/\t//g;
		$hash{$key} =~ s/\x{000D}\x{000A}/\n/g;
		$hash{$key} =~ tr/\x{000D}\x{000A}/\n\n/;
		$hash{$key} =~ s/\n$//;
		$hash{$key} =~ s/\s+$//;
	}
	return  \%hash;
}

sub count_mojisu
{
	my $str = shift;
	return length($str);
}


sub is_mail_address
{
	my $str   = shift;
	if ($str =~ /^([\w ! \. - ,]+)@([\w ! \. - ,]+$)/)
	{
		return 1;
	}else{
		return 0;
	}
}

sub check_FormData
{
	my $hash_ref = shift;
	my %hash = %$hash_ref;
	
	my @error;
	if (!$hash{"username"})
	{
		push (@error,"投稿者名を入力してください。");	
	}
	if (!$hash{"title"})
	{
		push (@error,"件名を入力してください。");
	}
	if (!$hash{"comment"})
	{
		push (@error,"投稿文を入力してください。");
	}
	elsif(&count_mojisu($hash{"comment"})>100)
	{
		push (@error, "投稿文は100文字以内で入力してください。");
	}
	if($hash{"email"} && !&is_mail_address($hash{"email"}))
	{
		push (@error, "メールアドレスの形式が不正です。");
	}
	if($#error > -1)
	{
		&error(join("<BR>\n", @error));
		exit;
	}
		return;
}

sub error
{
	my $str = shift;
	my $html =<<END_OF_HTML;
Content-type: text/html;

<HTML>
<HEAD>
<TITLE>エラー画面</TITLE>
<META http-equiv = "Content-Type" content = "text/html;
charset=Shift_JIS">
</HEAD>

<BODY bgcolor="#FFFFFF" text="#000000">
<HR>
<DIV align="center"><B>エラー</B></DIV>
<HR>
<DIV align="left"><FONT size="2">[ <A
href="javascript:history.back()">戻る ]</FONT></DIV>

<BR>
<BR>
<TABLE algin="center"><TR><TD 
align="left">$str</TD></TR></TABLE>
<BR>
<BR>
<BR>
<BR>
<HR noshade>
<DIV align="center"><FONT size="2">Copyright(c) あなたの名前</FONT></DIV>
</BODY>
</HTML>
END_OF_HTML

	print $html;
	return;
}

sub add_FileData
{
my $datafile = shift;
	my $hash_ref = shift;
	my %hash     = %$hash_ref;

	my $date = &get_date;
	$hash{"comment"} =~ s/\n/\00/g;

	my @savedata;
	push(@savedata, $hash{"username"}   || "");
	push(@savedata, $hash{"email"}      || "");
	push(@savedata, $hash{"url"}        || "");
	push(@savedata, $hash{"title"}      || "");
	push(@savedata, $hash{"comment"}    || "");
	push(@savedata, $date);
	push(@savedata, $ENV{"REMOTE_ADDR"} || "");

	my $fh = *FILEHANDLE;
	&fileopen($fh, "+<:utf8", $datafile);
	&filelock($fh,LOCK_EX);

	my @data = <$fh>;
	if($data[$#data] =~ /^(\d*)\t(.*)$/)
	{
		unshift(@savedata, $1 + 1);
	}else{
		unshift(@savedata, 1);
	}

	seek($fh, tell $fh, 0);

	print $fh join("\t", @savedata);
	print $fh "\n";
	&fileclose($fh);
}

sub get_date
{
	my( $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst ) = localtime(time);
	$year = 1900 + $year;
	$mon  = $mon + 1;
	$mon  = sprintf("%.2d",$mon);
	$mday = sprintf("%.2d",$mday);
	$wday = sprintf("%.2d",$wday);
	$hour = sprintf("%.2d",$hour);
	$min  = sprintf("%.2d",$min);
	return "$year$mon$mday$wday$hour$min";
}

sub display_HTML
{
	my $str = shift;
	my $html =<<END_OF_HTML;
Content-Type: text/html

<HTML>
<HEAD>
<TITLE>掲示板</TITLE>
<META http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
</HEAD>

<BODY bgcolor="#FFFFCC" text="#000000">
<HR>
<DIV align="center"><B>掲示板</B> </DIV>
<HR>
<DIV align="left"><FONT size="2">[ <A href="/index.html">トップへ</A> ]</FONT> </DIV>
<BR>
<BR>
<DIV align="center">$str</DIV>
<BR>
<BR>
<BR>
<BR>
<BR>
<BR>
<HR noshade>
<DIV align="center"><FONT size="2">Copyright(c) 2005 あなたの名前</FONT> </DIV>
</BODY>
</HTML>
END_OF_HTML

	print $html;
	return;
}

sub filelock{
	my $fh   = shift;
	my $LOCK_KIND = shift;
	eval("flock( $fh, $LOCK_KIND )");
	if ($@) {
		&error("$@：このシステムではflockを実行できません");
		exit;
	}
	return;
}

sub fileopen{
	my $fh       = shift;
	my $mode     = shift;
	my $filepath = shift;
	if(!open($fh, $mode, $filepath))
	{
		&error("$filepath を開けません");
		exit;
	}
	return;
}

sub fileclose{
	my $fh   = shift;
	close($fh);
	return;
}

__END__
