#!c:/Perl/bin/Perl.exe -w

use strict;
use Fcntl qw(:DEFAULT :flock);
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use Encode qw(from_to decode encode);
use open ':utf8';
use encoding 'utf8', STDOUT=>'shiftjis';

#定義
my $datafile = "C:\\Apache2\\data\\bbs.dat";

#メイン
{
	my @data = &read_FileData($datafile);
	my $string = &make_article_table(@data);
	&display_HTML($string);
	exit;
}


#サブルーチン
sub display_HTML
{
	my $str = shift || "";
	my $html =<<END_OF_HTML;
Content-Type: text/html

<HTML>
<HEAD>
<TITLE>投稿一覧</TITLE>
<META http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
</HEAD>

<BODY bgcolor="#FFFFCC" text="#000000">
<HR>
<DIV align="center"><B>掲示板</B> </DIV>
<HR>
<DIV align="left"><FONT size="2">[ <A href="/index.html">トップへ</A> ]</FONT> </DIV>
<BR>
<DIV align="center">$str</DIV>
<BR>
<BR>
<HR noshade>
<DIV align="center"><FONT size="2">Copyright(c) 2005 あなたの名前</FONT> </DIV>
</BODY>
</HTML>
END_OF_HTML

	print $html;
	return;
}

sub filelock{
	my $fh   = shift;
	my $LOCK_KIND = shift;
	eval("flock( $fh, $LOCK_KIND )");
	if ($@) {
		&error("$@：このシステムではflockを実行できません");
		exit;
	}
	return;
}

sub fileopen{
	my $fh       = shift;
	my $mode     = shift;
	my $filepath = shift;
	if(!open($fh, $mode, $filepath))
	{
		&error("$filepath を開けません");
		exit;
	}
	return;
}

sub fileclose{
	my $fh   = shift;
	close($fh);
	return;
}

sub error
{
	my $str = shift;
	my $html =<<END_OF_HTML;
Content-type: text/html;

<HTML>
<HEAD>
<TITLE>エラー画面</TITLE>
<META http-equiv = "Content-Type" content = "text/html;
charset=Shift_JIS">
</HEAD>

<BODY bgcolor="#FFFFFF" text="#000000">
<HR>
<DIV align="center"><B>エラー</B></DIV>
<HR>
<DIV align="left"><FONT size="2">[ <A
href="javascript:history.back()">戻る ]</FONT></DIV>

<BR>
<BR>
<TABLE algin="center"><TR><TD 
align="left">$str</TD></TR></TABLE>
<BR>
<BR>
<BR>
<BR>
<HR noshade>
<DIV align="center"><FONT size="2">Copyright(c) あなたの名前</FONT></DIV>
</BODY>
</HTML>
END_OF_HTML

	print $html;
	return;
}

sub read_FileData
{
	my $datafile = shift;
	my $fh = *FILEHANDLE;
	&fileopen($fh, "<:utf8", $datafile);
	&filelock($fh,LOCK_SH);
	my @data = <$fh>;
	&fileclose($fh);
	return @data;
}

sub make_article_table {
	my @data = @_;
	my $string;
	for (my $i = $#data; $i > -1; $i--){
		my $line = $data[$i];
		chomp($line);
		next if $line =~ /^\s*$/;

		my($num, $username, $email, $url, $title, $comment, $date, $remote_adrr) = split("\t",$line);

		$num         = &remove_tag($num);
		$username    = &remove_tag($username);
		$email       = &remove_tag($email);
		$title       = &remove_tag($title);
		$comment     = &remove_tag($comment);
		$date        = &remove_tag($date);
		$remote_adrr = &remove_tag($remote_adrr);

		$comment  =~ s/\00/<BR>/g;

		if($date =~ /^(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})$/)
		{
			my $yobi = ("日","月","火","水","木","金","土")[$4];
			$date = "$1/$2/$3($yobi) $5:$6"
		}

		if($email)
		{
			$username = '<A href="mailto:' . $email . '">' . $username . '</A>';
		}

		$url = &remove_tag_url($url);
		if($url)
		{
			$url = '<A href="' . $url . '" target="_blank">' . $url . '</A>';
		}

	    $string .=<<END_OF_TABLE;
<HR size="1">
<TABLE width="100%" cellpadding="3" cellspacing="0" border="0" align="center">
    <TR>
      <TD bgcolor="#FFCC33" nowrap colspan="2" valign="top">
         $num ：<B><FONT size="4">$title</FONT></B>
	    <FONT size="2"> $date</FONT>
	  </TD>
    </TR>
    <TR>
      <TD colspan="2" nowrap valign="top">
	    <FONT size="2">From: $username 　$url</FONT>
	  </TD>
    </TR>
    <TR>
      <TD width="1%" nowrap valign="top"></TD>
      <TD width="99%"  nowrap valign="top" align="left">
	  	<UL>$comment</UL>
      </TD>
    </TR>
  </TABLE>
END_OF_TABLE

	}
	return $string;
}

sub remove_tag
{
	my $str = shift;
	$str =~ s/&/&amp;/g;
	$str =~ s/</&lt;/g;
	$str =~ s/>/&gt;/g;
	$str =~ s/"/&quot;/g;
	$str =~ s/'/&#39;/g;
	return $str;
}

sub remove_tag_url {
	my $url = shift;
	return '' if (!$url);
	if($url =~ /[^;\/?:@&=+\$,A-Za-z0-9\-_.!~*'()%]/)
	{
		return '';
	}

	if($url !~ /^(http|https):/){
		return '';
	}

	$url =~ s/&/&amp;/g;
	$url =~ s/'/&#39;/g;
	return $url;
}


__END__
