# 画面関係
sub header
{
	my $title = shift;
	my $html =<<END_OF_HTML;
Content-Type: text/html

<HTML>
<HEAD>
<TITLE>$title</TITLE>
<META http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
</HEAD>

<BODY bgcolor="#FFFFCC" text="#000000">
<HR>
<DIV align="center"><B>$title</B></DIV>
<HR>
END_OF_HTML

	return $html;

}

sub footer
{
	my $html =<<END_OF_HTML;
<BR>
<BR>
<BR>
<HR noshade>
<DIV align="center"><FONT size="2">Copyright(c) 2005 あなたの名前</FONT> </DIV>
</BODY>
</HTML>

END_OF_HTML

	return $html;
}

sub display_HTML
{
	my $str   = shift;
	my $title = shift || '掲示板';
	my $html  = &header($title);

	$html .=<<END_OF_HTML;
<DIV align="left"><FONT size="2">[ <A href="/index.html">トップへ</A> ]</FONT> </DIV>
<BR>
<DIV align="center">$str</DIV>
END_OF_HTML

	$html .= &footer;
	print $html;
	return;
}

sub error
{
	my $str   = shift;
	my $html =<<END_OF_HTML;
    <TABLE align="center"><TR><TD align="left">$str</TD></TR></TABLE>
    <FONT size="2">修正する場合はブラウザの「戻る」を押してください。</FONT>
END_OF_HTML
	&display_HTML($html, 'エラー画面');
}

sub make_article_table 
{
	my $info   = shift;
	my @data   = @{$info->{'FILEDATA'}};
		
	#1ページ表示件数
	my $max_line = $info->{"MAXLINE"};

	#全体の件数
	my $all = $#data + 1;

	#最後のページ
	my $max_page  = int($all / $max_line);
	$max_page++ if $all % $max_line ;

	#表示ページ数の取得
	my $this_page = $info->{'FORMDATA'}->{'this_page'} || 1;
	my $which     = $info->{'FORMDATA'}->{'which'}     || "";

	if($which eq "next"){
		$this_page++;
	}elsif($which eq "before"){
		$this_page--;
	}

	#ページ数が1以下の場合は1を代入
	$this_page = 1         if $this_page < 1;

	#ページ数が最後のページより大きい場合は最後のページを代入
	$this_page = $max_page if $this_page > $max_page;


	#表示データの作成
	my $string;
	if($#data > -1)
	{
		@data    = reverse @data;
		my $start = ($this_page - 1) * $max_line;
		my $end   = $this_page * $max_line - 1;
		@lines    = @data[$start .. $end];
		#ページリンクの作成
		my $page_link = &make_page_link($info, $all, $max_page, $this_page);
		$string = $page_link;
		for my $line (@lines){
	    	chomp($line);
			next if $line =~ /^\s*$/;
			my $buf = &get_one_article($info, $line);
			$string .= $buf;
		}
		$string .= $page_link;
	}else{
		$string  = '<HR width="350">記事がありません。投稿をお願いします。<HR width="350">';
	}

	return $string;
}

sub make_page_link
{
	my $info      = shift;
	my $all       = shift;
	my $max_page  = shift;
	my $this_page = shift;
	my $script    = $info->{"SCRIPT"};

	my $befor_link;
	if($this_page > 1)
	{
		my $url = "$script?mode=view&this_page=$this_page&which=before";
		$befor_link = '<A href="' . $url . '">[前へ]</A>';
	}else{
		$befor_link = '<FONT color="#C0C0C0">[前へ]</FONT>';
	}

	my $next_link;
	if($this_page < $max_page)
	{
		my $url = "$script?mode=view&this_page=$this_page&which=next";
		$next_link = '<A href="' . $url . '">[次へ]</A>';
	}else{
		$next_link = '<FONT color="#C0C0C0">[次へ]</FONT>';
	}

	my $page_num_link;
	if($max_page > 1){
		for $i (1.. $max_page){
			if($i eq $this_page){
				$page_num_link .= "$i ";
			}else{
				my $url = "$script?mode=view&this_page=$i";
				$page_num_link .= '<A href="' . $url . '">' . $i . '</A> ';
			}
		}
	}

	my $string =<<END_OF_TABLE;
<DIV align="center">
		<FONT size="2">全$all件 $this_page/$max_page</FONT><BR>
		<FONT size="2">$befor_link</FONT>
		<FONT size="3">$page_num_link</FONT>
		<FONT size="2">$next_link</FONT>
</DIV>
END_OF_TABLE

	return $string;
}

sub get_one_article
{
	my $info   = shift;
	my $line   = shift;
	my $mode   = $info->{'MODE'};
	my $script = $info->{'SCRIPT'};

	my($num, $username, $email, $url, $title, $comment, $date, $remote_adrr) = split("\t",$line);

	#HTMLタグの除去処理
	$num         = &remove_tag($num);
	$username    = &remove_tag($username);
	$email       = &remove_tag($email);
	$title       = &remove_tag($title);
	$comment     = &remove_tag($comment);
	$date        = &remove_tag($date);
	$remote_adrr = &remove_tag($remote_adrr);

	$comment  =~ s/\00/<BR>/g;#改行を\00に変換して

	if($date =~ /^(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2}$)/)
	{
		my $yobi = ("日","月","火","水","木","金","土")[$4];
		$date = "$1/$2/$3($yobi) $5:$6"
	}

	if($email)
	{
		$username = '<A href="mailto:' . $email . '">' . $username . '</A>';
	}

	$url = &remove_tag_url($url);
	if($url)
	{
		$url = '<A href="' . $url . '" target="_blank">' . $url . '</A>';
	}

	my $string_del = "";
	if( ($mode ne "confirm_delete") && ($username) )
	{
		$script    .= "?mode=confirm_delete&num=$num";
		$string_del = ' <FONT size="2">[<A href="' . $script . '">削除</A>]</FONT>';
	}

	my $string =<<END_OF_TABLE;
<HR size="1">
<TABLE width="100%" cellpadding="3" cellspacing="0" border="0" align="center">
    <TR>
      <TD bgcolor="#FFCC33" nowrap colspan="2" valign="top">
	    $num：<B><FONT size="4">$title</FONT></B>
	    <FONT size="2"> $date</FONT>$string_del
	  </TD>
    </TR>
    <TR>
      <TD colspan="2" nowrap valign="top">
	    <FONT size="2">From: $username　$url</FONT>
	  </TD>
    </TR>
    <TR>
      <TD width="1%" nowrap valign="top"></TD>
      <TD width="99%"  nowrap valign="top" align="left">
	  	<UL>$comment</UL>
      </TD>
    </TR>
  </TABLE>
END_OF_TABLE

	return $string;
}

sub make_form
{
		my $info     = shift;
	my $script   = $info->{'SCRIPT'};

	my $html =<<END_OF_HTML;
<FORM method="POST" action="$script">
<INPUT type="hidden" name="mode" value="confirm">

  <TABLE width="570" cellpadding="3" cellspacing="2" border="0" align="center">
    <TR>
      <TD bgcolor="#FFCC33" nowrap width="141" valign="top">
        <B>投稿者名</B><B><FONT size="2" color="#FF0000">※</FONT></B>
      </TD>
      <TD width="417" valign="top">
        <INPUT type="text" size="50" maxlength="30" name="username" value="">
      </TD>
    </TR>

    <TR>
      <TD bgcolor="#FFCC33" nowrap valign="top">
        <B>メールアドレス</B>
      </TD>
      <TD valign="top">
        <INPUT type="text" size="50" maxlength="50" name="email" value="">
      </TD>
    </TR>

    <TR>
      <TD bgcolor="#FFCC33" nowrap valign="top">
        <B>ＵＲＬ</B>
      </TD>
      <TD valign="top">
        <INPUT type="text" size="50" maxlength="50" name="url" value="">
      </TD>
    </TR>

    <TR>
      <TD bgcolor="#FFCC33" nowrap width="141" valign="top">
        <B>件名</B><B><FONT size="2" color="#FF0000">※</FONT></B>
      </TD>
      <TD width="417" valign="top">
        <INPUT type="text" size="50" maxlength="50" name="title" value="">
      </TD>
    </TR>

    <TR>
      <TD width="141" nowrap bgcolor="#FFCC33" valign="top">
        <B>投稿文</B><B><FONT size="2" color="#FF0000">※</FONT></B><BR>（100文字以内）
      </TD>
      <TD nowrap width="417" valign="top">
        <TEXTAREA cols="50" name="comment" wrap="hard" rows="8"></TEXTAREA>
      </TD>
    </TR>

    <TR>
      <TD width="141" nowrap bgcolor="#FFCC33" valign="top">
        <B>パスワード</B>
      </TD>
      <TD nowrap width="417" valign="top">
        <INPUT type="text" size="8" maxlength="8" name="password" value="">
		<FONT size="2">削除用、半角英数字8文字まで。</FONT><BR>
		<FONT size="2">パスワードがない場合は削除できません。</FONT><BR>
      </TD>
    </TR>

  </TABLE>


  <DIV align="center">
    <INPUT type="submit" name="submit" value=" 投稿 ">
    <INPUT type="reset"  name="reset"  value=" リセット ">
  </DIV>

  <BR>

  <DIV align="center">
    <FONT size="2">
      「投稿」を押して確認画面を表示してください。</FONT><BR>
    <B><FONT size="2" color="#FF0000">※</FONT></B>
    <FONT size="2">[必須項目]は必ず入力して下さい。</FONT><BR>
  </DIV>

</FORM>
END_OF_HTML
	return $html;
}

sub make_confirm_form
{
	my $info     = shift;
	my $script   = $info->{'SCRIPT'};
	my $hash_ref = $info->{'FORMDATA'};

	my $comment = $hash_ref->{'comment'};
	$comment =~ s/\n/<BR>/g;

	my $html =<<END_OF_HTML;
<FORM method="POST" action="$script">
<INPUT type="hidden" name="mode" value="post">

  <TABLE width="570" cellpadding="3" cellspacing="2" border="0" align="center">
    <TR>
      <TD bgcolor="#FFCC33" nowrap width="141" valign="top">
        <B>投稿者名</B><B><FONT size="2" color="#FF0000">※</FONT></B>
      </TD>
      <TD width="417" valign="top">
        $hash_ref->{'username'}
		<INPUT type="hidden" name="username" value="$hash_ref->{'username'}">
      </TD>
    </TR>

    <TR>
      <TD bgcolor="#FFCC33" nowrap valign="top">
        <B>メールアドレス</B>
      </TD>
      <TD valign="top">
        $hash_ref->{'email'}
		<INPUT type="hidden" name="email" value="$hash_ref->{'email'}">
      </TD>
    </TR>

    <TR>
      <TD bgcolor="#FFCC33" nowrap valign="top">
        <B>ＵＲＬ</B>
      </TD>
      <TD valign="top">
        $hash_ref->{'url'}
		<INPUT type="hidden" name="url" value="$hash_ref->{'url'}">
      </TD>
    </TR>

    <TR>
      <TD bgcolor="#FFCC33" nowrap width="141" valign="top">
        <B>件名</B><B><FONT size="2" color="#FF0000">※</FONT></B>
      </TD>
      <TD width="417" valign="top">
        $hash_ref->{'title'}
		<INPUT type="hidden" name="title" value="$hash_ref->{'title'}">
      </TD>
    </TR>

    <TR>
      <TD width="141" nowrap bgcolor="#FFCC33" valign="top">
        <B>投稿文</B><B><FONT size="2" color="#FF0000">※</FONT></B><BR>（100文字以内）
      </TD>
      <TD nowrap width="417" valign="top">
        $comment
		<INPUT type="hidden" name="comment" value="$hash_ref->{'comment'}">
      </TD>
    </TR>

    <TR>
      <TD width="141" nowrap bgcolor="#FFCC33" valign="top">
        <B>パスワード</B>
      </TD>
      <TD nowrap width="417" valign="top">
        $hash_ref->{'password'}
		<INPUT type="hidden" name="password" value="$hash_ref->{'password'}">
      </TD>
    </TR>

  </TABLE>


  <DIV align="center">
    <INPUT type="submit" name="submit" value=" 確認 ">
  </DIV>

  <BR>

  <DIV align="center">
    <FONT size="2">
      「確認」を押すと掲示板に書き込みます。<BR>
       修正する場合はブラウザの「戻る」を押してください。</FONT>
  </DIV>

</FORM>
END_OF_HTML
	return $html;
}

sub make_delete_form
{
	my $info     = shift;
	my $script   = $info->{'SCRIPT'};
	my $hash_ref = $info->{'FORMDATA'};
	my @data     = @{$info->{'FILEDATA'}};
	my $num      = $hash_ref->{'num'};

	my $array_num = 0;
	for my $line (@data)
	{
		last if $line =~ /^$num\t/;
		$array_num++;
	}

	my $line = $data[$array_num];
	if(!$line)
	{
		&error("記事が見つかりません。");
		exit;
	}
	chomp($line);
	my $article = &get_one_article($info, $line);

	my $html =<<END_OF_HTML;
<FORM method="POST" action="$script">
<INPUT type="hidden" name="mode" value="delete">
<INPUT type="hidden" name="num" value="$num">

$article

  <BR>
  <BR>
  <HR size="1" width="350">
  <DIV align="center">
    <FONT size="2"><B>パスワード：</B></FONT>
	<INPUT type="password" size="8" maxlength="8" name="password" value="">
	<BR>
	<BR>
    <INPUT type="submit" name="submit" value=" 確認 ">
  </DIV>

  <BR>

  <DIV align="center">
    <FONT size="2">
	   投稿時にパスワードが登録されていない場合は削除できません。<BR>
      「確認」を押すとこの記事をサーバーから完全に削除します。<BR>
       削除しない場合は、ブラウザの「戻る」を押してください。</FONT>
  </DIV>
  <HR size="1" width="350">

</FORM>
END_OF_HTML
	return $html;
}



# ファイル関係
sub filelock{
	my $fh        = shift;
	my $LOCK_KIND = shift;
	eval("flock( $fh, $LOCK_KIND )");
	if ($@) {
		&error("$@：このシステムではflockを実行できません");
		exit;
	}
	return;
}

sub fileopen{
	my $fh       = shift;
	my $mode     = shift;
	my $filepath = shift;
	if(!open($fh, $mode, $filepath))
	{
		&error("$filepath を開けません");
		exit;
	}
	return;
}

sub fileclose{
	my $fh        = shift;
	close($fh);
	return;
}

sub read_FileData
{
	my $info = shift;
	my $datafile = $info->{'DATAFILE'};

	my $fh = *FILEHANDLE;
	&fileopen($fh, "<:utf8", $datafile);
	&filelock($fh,LOCK_SH);
	my @data = <$fh>;
	&fileclose($fh);
	return @data;
}

sub add_FileData
{
	my $info = shift;
	my $datafile = $info->{'DATAFILE'};
	my $hash_ref = $info->{'FORMDATA'};
	
	my %hash = %$hash_ref;
	my $date = $info->{'NOW_DATE'};

	$hash{"comment"} =~ s/\n/\00/g;

	my @savedata;
	push(@savedata, $hash{"username"}   || "");
	push(@savedata, $hash{"email"}      || "");
	push(@savedata, $hash{"url"}        || "");
	push(@savedata, $hash{"title"}      || "");
	push(@savedata, $hash{"comment"}    || "");
	push(@savedata, $date);
	push(@savedata, $ENV{"REMOTE_ADDR"} || "");
	push(@savedata,$hash{"password"});	

	my $fh = *FILEHANDLE;
	&fileopen($fh, "+<:utf8", $datafile);
	&filelock($fh,LOCK_EX);

	my @data = <$fh>;
	if($data[$#data] =~ /^(\d*)\t(.*)$/)
	{
		unshift(@savedata, $1 + 1);
	}else{
		unshift(@savedata, 1);
	}
	
	
#投稿を制限する
	my $max  = $info->{"MAX"};
	my $post = $#data + 1;
	if($max < $post)
	{

		for (my $i = 1; $i <= $post - $max + 1; $i++ )
		{
			shift @data;
		}
		push(@data, join("\t", @savedata) . "\n");

		seek($fh, 0, 0);
		truncate($fh, 0);

		for my $line (@data)
		{
			print $fh $line ;
		}
	}else{
		seek($fh, tell $fh, 0);

		print $fh join("\t", @savedata);
		print $fh "\n";#最後に改行を出力
	}
	&fileclose($fh);
}


sub del_FileData
{
	my $info     = shift;
	my $datafile = $info->{'DATAFILE'};
	my $hash_ref = $info->{'FORMDATA'};

	my %hash     = %$hash_ref;

	my $date = $info->{'NOW_DATE'};

	my $admin_flag = 0;
	if( &is_password_match($hash{"password"}, $info->{"PASSWORD"}) )
	{
		$admin_flag = 1;
	}

	my @savedata;
	push(@savedata, $hash{"num"});
	push(@savedata, "");
	push(@savedata, "");
	push(@savedata, "");
	push(@savedata, "削除済み");
	if($admin_flag){
		push(@savedata, "管理者により削除されました。");
	}else{
		push(@savedata, "ユーザーにより削除されました。");
	}
	push(@savedata, $date);
	push(@savedata, $ENV{"REMOTE_ADDR"} || "");
	push(@savedata, "");

	my $fh = *FILEHANDLE;
	&fileopen($fh, "+<:utf8", $datafile);
	&filelock($fh,LOCK_EX);

	my @data = <$fh>;

	my $array_num = 0;
	for my $line (@data)
	{
		last if $line =~ /^$hash{"num"}\t/;
		$array_num++;
	}

	my $delete_flag = 0;
	if($data[$array_num] =~ /\t([A-Za-z0-9]{1,8})$/)
	{
		if( &is_password_match($1, $hash{"password"}))
		{
			$delete_flag = 1;
		}
	}

	if( $delete_flag or $admin_flag)
	{
			$data[$array_num] = join("\t", @savedata) . "\n";

			#ファイルの位置を、読み込み後の位置に設定
			seek($fh, 0, 0);
			truncate($fh, 0);

			#タブ区切りのデータをファイルに書き込む
			for my $line (@data)
			{
				print $fh $line ;
			}
			&fileclose($fh);
	}else{
		&fileclose($fh);
		&error("記事を削除できません。");
		exit;
	}

}


# POST・GET関係
sub get_FormData {
	my $obj = shift;
	my @hash_name = $obj->param;
	my %hash;
	foreach my $key(@hash_name)
	{
		$hash{$key} = decode('shiftjis', $obj->param($key));
		next if $hash{$key} =~ /^\s*$/;
		$hash{$key} =~ s/\t//g;
		$hash{$key} =~ s/\x{000D}\x{000A}/\n/g;
		$hash{$key} =~ tr/\x{000D}\x{000A}/\n\n/;
		$hash{$key} =~ s/\n$//;
		$hash{$key} =~ s/\s+$//;
	}
	return  \%hash;
}


# チェック関係
sub remove_tag
{
	my $str = shift;
	$str =~ s/&/&amp;/g;
	$str =~ s/</&lt;/g;
	$str =~ s/>/&gt;/g;
	$str =~ s/"/&quot;/g;
	$str =~ s/'/&#39;/g;
	return $str;
}


sub remove_tag_url {
	my $url = shift;
	return '' if (!$url);
	if($url =~ /[^;\/?:@&=+\$,A-Za-z0-9\-_.!~*'()%]/)
	{
		return '';
	}

	if($url !~ /^(http|https):/){
		return '';
	}

	$url =~ s/&/&amp;/g;
	$url =~ s/'/&#39;/g;
	return $url;
}


sub count_mojisu
{
	my $str = shift;
	return length($str);
}


sub is_mail_address
{
	my $str = shift;
	if ($str =~ /^([\w ! \. - ,]+)@([\w ! \. - ,]+$)/)
	{
		return 1;
	}else{
		return 0;
	}
}

sub check_FormData
{
	my $info = shift;
	my $hash_ref = $info->{'FORMDATA'};
	my %hash = %$hash_ref;

	my @error;
	if(!$hash{"username"}){ push(@error, "投稿者名を入力してください。");}
	if(!$hash{"title"})   { push(@error, "件名を入力してください。");}
	if(!$hash{"comment"})
	{
		push(@error, "投稿文を入力してください。");
	}elsif(&count_mojisu($hash{"comment"}) > 100){
		push(@error, "投稿文は100文字以内で入力してください。");
	}

	if($hash{"email"} && !&is_mail_address($hash{"email"})){
		push(@error, "メールアドレスの形式が不正です。");
	}
	
	if($hash{"password"} && !&is_password($hash{"password"})){
		push(@error, "パスワードの形式が不正です。");
	}
	if($#error > -1)
	{
		&error(join("<BR>\n", @error));
		exit;
	}
	return;
}

sub check_GetData
{
	my $info     = shift;
	my $hash_ref = $info->{'FORMDATA'};
	my %hash = %$hash_ref;

	my @error;
	if($hash{"this_page"} && !&is_numeric($hash{"this_page"})){
		&error("不正な操作です。");
		exit;
	}

	if($hash{"which"} && !($hash{"which"} eq "before" || $hash{"which"} eq "next")){
		&error("不正な操作です。");
		exit;
	}

	return;
}

sub check_FormData_delete
{
	my $info     = shift;
	my $hash_ref = $info->{'FORMDATA'};
	my %hash = %$hash_ref;

	my @error;

	if(!$hash{"password"}){
		push(@error, "パスワードを入力してください。");
	}elsif($hash{"password"} && !&is_password($hash{"password"})){
		push(@error, "パスワードの形式が不正です。");
	}

	if(!$hash{"num"}){
		push(@error, "不正な操作です。");
	}elsif($hash{"num"} && !&is_numeric($hash{"num"})){
		push(@error, "不正な操作です。");
	}

	if($#error > -1)
	{
		&error(join("<BR>\n", @error));
		exit;
	}
	return;
}

sub is_password
{
	my $str = shift;
	if( $str =~ /^[A-Za-z0-9]{1,8}$/ )
	{
		return 1;
	}else{
		return 0;
	}
}

sub is_numeric
{
	my $str = shift;
	if ( $str =~ /\D/ )
	{
		return 0;
	}
	return 1;
}

sub is_password_match
{
	$input = shift;
	$saved = shift;

	if($input eq  $saved)
	{
		return 1;
	}else{
		return 0;
	}
}

# 時間関係

sub get_date
{
	my( $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst ) = localtime(time);
	$year = 1900 + $year;
	$mon  = $mon + 1;
	$mon  = sprintf("%.2d",$mon);
	$mday = sprintf("%.2d",$mday);
	$wday = sprintf("%.2d",$wday);
	$hour = sprintf("%.2d",$hour);
	$min  = sprintf("%.2d",$min);
	return "$year$mon$mday$wday$hour$min";
}



1;
